Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 Documentation/i2c/porting-clients |    3 ++-
 Documentation/i2c/writing-clients |    4 +---
 drivers/hwmon/adm1021.c           |    4 +---
 drivers/hwmon/adm1025.c           |    5 +----
 drivers/hwmon/adm9240.c           |    5 +----
 drivers/hwmon/asb100.c            |    5 +----
 drivers/hwmon/ds1621.c            |    5 +----
 drivers/hwmon/fscher.c            |    5 +----
 drivers/hwmon/fscpos.c            |    5 +----
 drivers/hwmon/gl518sm.c           |    5 +----
 drivers/hwmon/gl520sm.c           |    5 +----
 drivers/hwmon/it87.c              |    5 +----
 drivers/hwmon/lm63.c              |    5 +----
 drivers/hwmon/lm78.c              |    5 +----
 drivers/hwmon/lm80.c              |    5 +----
 drivers/hwmon/lm83.c              |    5 +----
 drivers/hwmon/lm87.c              |    5 +----
 drivers/hwmon/lm90.c              |    5 +----
 drivers/hwmon/lm92.c              |    5 +----
 drivers/hwmon/max1619.c           |    5 +----
 drivers/hwmon/pc87360.c           |    5 +----
 drivers/hwmon/sis5595.c           |    5 +----
 drivers/hwmon/smsc47b397.c        |    5 +----
 drivers/hwmon/smsc47m1.c          |    5 +----
 drivers/hwmon/via686a.c           |    5 +----
 drivers/hwmon/w83627ehf.c         |    5 +----
 drivers/hwmon/w83627hf.c          |    5 +----
 drivers/hwmon/w83781d.c           |    5 +----
 drivers/hwmon/w83792d.c           |    5 +----
 drivers/hwmon/w83l785ts.c         |    5 +----
 drivers/i2c/chips/ds1337.c        |    5 +----
 drivers/i2c/chips/eeprom.c        |    4 +---
 drivers/i2c/chips/pca9539.c       |    4 +---
 drivers/i2c/chips/pcf8574.c       |    5 +----
 drivers/i2c/chips/pcf8591.c       |    5 +----
 drivers/i2c/i2c-core.c            |    6 +++++-
 i2c/chips/max6875.c               |    0 
 37 files changed, 41 insertions(+), 134 deletions(-)

diff -puN Documentation/i2c/porting-clients~gregkh-i2c-i2c-refactor-message Documentation/i2c/porting-clients
--- devel/Documentation/i2c/porting-clients~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/Documentation/i2c/porting-clients	2005-07-30 13:15:36.000000000 -0700
@@ -94,7 +94,8 @@ Technical changes:
   limited to the strictly necessary steps.
 
 * [Detach] Get rid of data, remove the call to
-  i2c_deregister_entry.
+  i2c_deregister_entry. Do not log an error message if
+  i2c_detach_client fails, as i2c-core will now do it for you.
 
 * [Update] Don't access client->data directly, use
   i2c_get_clientdata(client) instead.
diff -puN Documentation/i2c/writing-clients~gregkh-i2c-i2c-refactor-message Documentation/i2c/writing-clients
--- devel/Documentation/i2c/writing-clients~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/Documentation/i2c/writing-clients	2005-07-30 13:15:36.000000000 -0700
@@ -489,10 +489,8 @@ much simpler than the attachment code, f
     /* SENSORS ONLY END */
 
     /* Try to detach the client from i2c space */
-    if ((err = i2c_detach_client(client))) {
-      printk("foo.o: Client deregistration failed, client not detached.\n");
+    if ((err = i2c_detach_client(client)))
       return err;
-    }
 
     /* HYBRID SENSORS CHIP ONLY START */
     if i2c_is_isa_client(client)
diff -puN drivers/hwmon/adm1021.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/adm1021.c
--- devel/drivers/hwmon/adm1021.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/adm1021.c	2005-07-30 13:15:36.000000000 -0700
@@ -328,10 +328,8 @@ static int adm1021_detach_client(struct 
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/adm1025.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/adm1025.c
--- devel/drivers/hwmon/adm1025.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/adm1025.c	2005-07-30 13:15:36.000000000 -0700
@@ -517,11 +517,8 @@ static int adm1025_detach_client(struct 
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/adm9240.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/adm9240.c
--- devel/drivers/hwmon/adm9240.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/adm9240.c	2005-07-30 13:15:36.000000000 -0700
@@ -645,11 +645,8 @@ static int adm9240_detach_client(struct 
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-				"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/asb100.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/asb100.c
--- devel/drivers/hwmon/asb100.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/asb100.c	2005-07-30 13:15:36.000000000 -0700
@@ -867,11 +867,8 @@ static int asb100_detach_client(struct i
 	if (data)
 		hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "client deregistration failed; "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	/* main client */
 	if (data)
diff -puN drivers/hwmon/ds1621.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/ds1621.c
--- devel/drivers/hwmon/ds1621.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/ds1621.c	2005-07-30 13:15:36.000000000 -0700
@@ -282,11 +282,8 @@ static int ds1621_detach_client(struct i
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 
diff -puN drivers/hwmon/fscher.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/fscher.c
--- devel/drivers/hwmon/fscher.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/fscher.c	2005-07-30 13:15:36.000000000 -0700
@@ -383,11 +383,8 @@ static int fscher_detach_client(struct i
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/fscpos.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/fscpos.c
--- devel/drivers/hwmon/fscpos.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/fscpos.c	2005-07-30 13:15:36.000000000 -0700
@@ -549,11 +549,8 @@ static int fscpos_detach_client(struct i
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, client"
-							" not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 	kfree(data);
 	return 0;
 }
diff -puN drivers/hwmon/gl518sm.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/gl518sm.c
--- devel/drivers/hwmon/gl518sm.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/gl518sm.c	2005-07-30 13:15:36.000000000 -0700
@@ -492,11 +492,8 @@ static int gl518_detach_client(struct i2
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/gl520sm.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/gl520sm.c
--- devel/drivers/hwmon/gl520sm.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/gl520sm.c	2005-07-30 13:15:36.000000000 -0700
@@ -654,11 +654,8 @@ static int gl520_detach_client(struct i2
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/it87.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/it87.c
--- devel/drivers/hwmon/it87.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/it87.c	2005-07-30 13:15:36.000000000 -0700
@@ -945,11 +945,8 @@ static int it87_detach_client(struct i2c
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev,
-			"Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	if(i2c_is_isa_client(client))
 		release_region(client->addr, IT87_EXTENT);
diff -puN drivers/hwmon/lm63.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/lm63.c
--- devel/drivers/hwmon/lm63.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/lm63.c	2005-07-30 13:15:36.000000000 -0700
@@ -520,11 +520,8 @@ static int lm63_detach_client(struct i2c
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/lm78.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/lm78.c
--- devel/drivers/hwmon/lm78.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/lm78.c	2005-07-30 13:15:36.000000000 -0700
@@ -683,11 +683,8 @@ static int lm78_detach_client(struct i2c
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev,
-		    "Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	if(i2c_is_isa_client(client))
 		release_region(client->addr, LM78_EXTENT);
diff -puN drivers/hwmon/lm80.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/lm80.c
--- devel/drivers/hwmon/lm80.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/lm80.c	2005-07-30 13:15:36.000000000 -0700
@@ -510,11 +510,8 @@ static int lm80_detach_client(struct i2c
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/lm83.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/lm83.c
--- devel/drivers/hwmon/lm83.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/lm83.c	2005-07-30 13:15:36.000000000 -0700
@@ -363,11 +363,8 @@ static int lm83_detach_client(struct i2c
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev,
-		    "Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/lm87.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/lm87.c
--- devel/drivers/hwmon/lm87.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/lm87.c	2005-07-30 13:15:36.000000000 -0700
@@ -734,11 +734,8 @@ static int lm87_detach_client(struct i2c
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/lm90.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/lm90.c
--- devel/drivers/hwmon/lm90.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/lm90.c	2005-07-30 13:15:36.000000000 -0700
@@ -562,11 +562,8 @@ static int lm90_detach_client(struct i2c
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/lm92.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/lm92.c
--- devel/drivers/hwmon/lm92.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/lm92.c	2005-07-30 13:15:36.000000000 -0700
@@ -399,11 +399,8 @@ static int lm92_detach_client(struct i2c
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/max1619.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/max1619.c
--- devel/drivers/hwmon/max1619.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/max1619.c	2005-07-30 13:15:36.000000000 -0700
@@ -322,11 +322,8 @@ static int max1619_detach_client(struct 
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/hwmon/pc87360.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/pc87360.c
--- devel/drivers/hwmon/pc87360.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/pc87360.c	2005-07-30 13:15:36.000000000 -0700
@@ -984,11 +984,8 @@ static int pc87360_detach_client(struct 
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((i = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((i = i2c_detach_client(client)))
 		return i;
-	}
 
 	for (i = 0; i < 3; i++) {
 		if (data->address[i]) {
diff -puN drivers/hwmon/sis5595.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/sis5595.c
--- devel/drivers/hwmon/sis5595.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/sis5595.c	2005-07-30 13:15:36.000000000 -0700
@@ -618,11 +618,8 @@ static int sis5595_detach_client(struct 
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev,
-		    "Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	release_region(client->addr, SIS5595_EXTENT);
 
diff -puN drivers/hwmon/smsc47b397.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/smsc47b397.c
--- devel/drivers/hwmon/smsc47b397.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/smsc47b397.c	2005-07-30 13:15:36.000000000 -0700
@@ -214,11 +214,8 @@ static int smsc47b397_detach_client(stru
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	release_region(client->addr, SMSC_EXTENT);
 	kfree(data);
diff -puN drivers/hwmon/smsc47m1.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/smsc47m1.c
--- devel/drivers/hwmon/smsc47m1.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/smsc47m1.c	2005-07-30 13:15:36.000000000 -0700
@@ -497,11 +497,8 @@ static int smsc47m1_detach_client(struct
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	release_region(client->addr, SMSC_EXTENT);
 	kfree(data);
diff -puN drivers/hwmon/via686a.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/via686a.c
--- devel/drivers/hwmon/via686a.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/via686a.c	2005-07-30 13:15:36.000000000 -0700
@@ -700,11 +700,8 @@ static int via686a_detach_client(struct 
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev,
-		"Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	release_region(client->addr, VIA686A_EXTENT);
 	kfree(data);
diff -puN drivers/hwmon/w83627ehf.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/w83627ehf.c
--- devel/drivers/hwmon/w83627ehf.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/w83627ehf.c	2005-07-30 13:15:36.000000000 -0700
@@ -774,11 +774,8 @@ static int w83627ehf_detach_client(struc
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 	release_region(client->addr, REGION_LENGTH);
 	kfree(data);
 
diff -puN drivers/hwmon/w83627hf.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/w83627hf.c
--- devel/drivers/hwmon/w83627hf.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/w83627hf.c	2005-07-30 13:15:36.000000000 -0700
@@ -1157,11 +1157,8 @@ static int w83627hf_detach_client(struct
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev,
-		       "Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	release_region(client->addr, WINB_EXTENT);
 	kfree(data);
diff -puN drivers/hwmon/w83781d.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/w83781d.c
--- devel/drivers/hwmon/w83781d.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/w83781d.c	2005-07-30 13:15:36.000000000 -0700
@@ -1299,11 +1299,8 @@ w83781d_detach_client(struct i2c_client 
 	if (i2c_is_isa_client(client))
 		release_region(client->addr, W83781D_EXTENT);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev,
-		       "Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	/* main client */
 	if (data)
diff -puN drivers/hwmon/w83792d.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/w83792d.c
--- devel/drivers/hwmon/w83792d.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/w83792d.c	2005-07-30 13:15:36.000000000 -0700
@@ -1396,11 +1396,8 @@ w83792d_detach_client(struct i2c_client 
 	if (data)
 		hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev,
-			"Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	/* main client */
 	if (data)
diff -puN drivers/hwmon/w83l785ts.c~gregkh-i2c-i2c-refactor-message drivers/hwmon/w83l785ts.c
--- devel/drivers/hwmon/w83l785ts.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/hwmon/w83l785ts.c	2005-07-30 13:15:36.000000000 -0700
@@ -267,11 +267,8 @@ static int w83l785ts_detach_client(struc
 
 	hwmon_device_unregister(data->class_dev);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(data);
 	return 0;
diff -puN drivers/i2c/chips/ds1337.c~gregkh-i2c-i2c-refactor-message drivers/i2c/chips/ds1337.c
--- devel/drivers/i2c/chips/ds1337.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/i2c/chips/ds1337.c	2005-07-30 13:15:36.000000000 -0700
@@ -353,11 +353,8 @@ static int ds1337_detach_client(struct i
 	int err;
 	struct ds1337_data *data = i2c_get_clientdata(client);
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed, "
-			"client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	list_del(&data->list);
 	kfree(data);
diff -puN drivers/i2c/chips/eeprom.c~gregkh-i2c-i2c-refactor-message drivers/i2c/chips/eeprom.c
--- devel/drivers/i2c/chips/eeprom.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/i2c/chips/eeprom.c	2005-07-30 13:15:36.000000000 -0700
@@ -230,10 +230,8 @@ static int eeprom_detach_client(struct i
 	int err;
 
 	err = i2c_detach_client(client);
-	if (err) {
-		dev_err(&client->dev, "Client deregistration failed, client not detached.\n");
+	if (err)
 		return err;
-	}
 
 	kfree(i2c_get_clientdata(client));
 
diff -puN drivers/i2c/chips/max6875.c~gregkh-i2c-i2c-refactor-message drivers/i2c/chips/max6875.c
diff -puN drivers/i2c/chips/pca9539.c~gregkh-i2c-i2c-refactor-message drivers/i2c/chips/pca9539.c
--- devel/drivers/i2c/chips/pca9539.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/i2c/chips/pca9539.c	2005-07-30 13:15:36.000000000 -0700
@@ -163,10 +163,8 @@ static int pca9539_detach_client(struct 
 {
 	int err;
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev, "Client deregistration failed.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(i2c_get_clientdata(client));
 	return 0;
diff -puN drivers/i2c/chips/pcf8574.c~gregkh-i2c-i2c-refactor-message drivers/i2c/chips/pcf8574.c
--- devel/drivers/i2c/chips/pcf8574.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/i2c/chips/pcf8574.c	2005-07-30 13:15:36.000000000 -0700
@@ -185,11 +185,8 @@ static int pcf8574_detach_client(struct 
 {
 	int err;
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev,
-			"Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(i2c_get_clientdata(client));
 	return 0;
diff -puN drivers/i2c/chips/pcf8591.c~gregkh-i2c-i2c-refactor-message drivers/i2c/chips/pcf8591.c
--- devel/drivers/i2c/chips/pcf8591.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/i2c/chips/pcf8591.c	2005-07-30 13:15:36.000000000 -0700
@@ -240,11 +240,8 @@ static int pcf8591_detach_client(struct 
 {
 	int err;
 
-	if ((err = i2c_detach_client(client))) {
-		dev_err(&client->dev,
-			"Client deregistration failed, client not detached.\n");
+	if ((err = i2c_detach_client(client)))
 		return err;
-	}
 
 	kfree(i2c_get_clientdata(client));
 	return 0;
diff -puN drivers/i2c/i2c-core.c~gregkh-i2c-i2c-refactor-message drivers/i2c/i2c-core.c
--- devel/drivers/i2c/i2c-core.c~gregkh-i2c-i2c-refactor-message	2005-07-30 13:15:36.000000000 -0700
+++ devel-akpm/drivers/i2c/i2c-core.c	2005-07-30 13:15:36.000000000 -0700
@@ -449,8 +449,12 @@ int i2c_detach_client(struct i2c_client 
 	struct i2c_adapter *adapter = client->adapter;
 	int res = 0;
 	
-	if ((client->flags & I2C_CLIENT_ALLOW_USE) && (client->usage_count > 0))
+	if ((client->flags & I2C_CLIENT_ALLOW_USE)
+	 && (client->usage_count > 0)) {
+		dev_warn(&client->dev, "Client [%s] still busy, "
+			 "can't detach\n", client->name);
 		return -EBUSY;
+	}
 
 	if (adapter->client_unregister)  {
 		res = adapter->client_unregister(client);
_
